using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Transactions;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Threading.Tasks;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Widgets;
using Silk.NET.Input;
using Silk.NET.OpenAL;
using Silk.NET.SDL;
using SixLabors.ImageSharp.Processing;
using Button = Jypeli.Button;
using Color = Jypeli.Color;
using Key = Jypeli.Key;
using MouseButton = Jypeli.MouseButton;
using Window = Jypeli.Window;

/// @author Miklas, Joonatan, Santeri
/// @version 0.69.420
/// <summary>
/// Pelissä koitetaan pelastaa pelaajan poika joka on joutunut venäläisen mafian kidnappaamaksi.
/// He vaativat lunnasrahoja joita sinulla ei ole ja päätät suunnata kasinolle tienaamaan
/// Kasinolla voit voittaa 10000000% rahastasi takaisin mutta hävitä vain 100% joten sehän on kannattavaa

/// Pelaa erilaisia minipelejä kasvattaen rahamäärääsi kohti miljardia 1 000 000 000€ 
/// Kontrollit on peleissä näytetty merkinnöillä (*nappi*), peli vaatii suurimmilta osin näppäimistöä mutta joskus joudut käyttämään myös hiirtäsi.

///Credits:
/// Miklas: Plinko, Slots, yleinen ulkoasu
/// Joonatan: Blackjack, Coinflip, yleinen ulkoasu
/// Santeri: Ruletti(ei tehty), kuvat(ei kaikki), aloitus ja lopetus kuvat (ei tehty)
/// </summary>

//Seuraavaksi:
//minimi/maksimipanokset, slots ei minimiä mutta joku maksimi koska muuten op, plinko pieni minimi ei maksimia (ehkä)
//bj suurempi minimi ei max, cf sama??

//ruletti?????

namespace Financial_Freedom{

public class Card // tehdään kortit
{
    public string Suit { get; }// hakee pelikortin maan
    public string Rank { get; }// hakee pelikortin numeron
    
    public int BjCardValue { get; } // hakee pelikortin arvon

    public Card(string suit, string rank) //tekee muuttujan card jolla on kolme arvoa: maa, numero, arvo bj:ssä
    {
        Suit = suit; // kortin maa
        Rank = rank; // kortin numero
        BjCardValue = GetCardValue(rank); // Määritetään arvo rankin perusteella
    }

    private int GetCardValue(string rank)
    {
        // Palauttaa kortin arvon blackjackia varten koska pelissä kuvakortit on 10 ja ässä on 11 kunnes menee yli 21 jolloin siitä tulee 1 tekee sen Rankin mukaan
        return rank switch
        {
            "2" => 2,
            "3" => 3,
            "4" => 4,
            "5" => 5,
            "6" => 6,
            "7" => 7,
            "8" => 8,
            "9" => 9,
            "10" => 10,
            "J" => 10,
            "Q" => 10,
            "K" => 10,
            "A" => 11, // Muista vaihtaa 1 jos menee yli
            _ => 0 // oletusarvo jos rank ei vastaa mitään yllä olevista
        };
    }    
    
    public override string ToString()
    {
        return $"{Rank}{Suit}"; //kuvia varten tarvitaan string esim. Pata4
    }
}

public class RouletteBet
{
    public string Name { get; }    // Panoskohteen nimi ("0", "00", "28", jne.)
    public string Color { get; }   // Väri ("Green", "Red", "Black")
    public double Angle { get; }   // Kulma-arvo asteina, jossa panoskohde sijaitsee pöydällä

    public RouletteBet(string name, string color, double angle)
    {
        Name = name;
        Color = color;
        Angle = angle;
    }

    public override string ToString()
    {
        return $"{Name} {Color} at {Angle}";
    }
}


public class  Financial_Freedom : PhysicsGame
//alustellaan muuttujat
{
    private double yTs = 1; // Yleinen Takaisinsaanti
    private double tsplinko = (1); //suurinpiirtein takaisinsaantikerroin plinkoalustoissa 0.85 kontrollikerroin
    DoubleMeter pistelaskuri; //heitäppä villi veikkaus mikä tämä voisi olla
    private Label panosLabel; // Label, joka näyttää panoksen no shit
    private double panos; // Alkustus panokselle
    private TaskCompletionSource<bool> panosAsetettu;
    private Label pistenaytto;
    private GameObject coinObject;
    private TaskCompletionSource<bool> animaatioValmis;
    private List<Card> pakka = new List<Card>();  // Tehdään pakasta luokan kenttä
    private List<Card> pelaajanKortit = new List<Card>(); // Pelaajan kortit kentäksi
    private List<Card> jakajanKortit; // Jakajan kortit kentäksi
    
    private List<string> clickLog = new List<string>(); //ruletin panostuksen clikkailulogi
    private List<string> Betit; //läpikäyty klikkauslogi
    private GameObject doneButton = null;
    
    private int peliKesken = 0;
    
    private double kerroinCF = 1;  // Pelin kerroin, joka kasvaa voiton myötä
    private double keratytRahatCF = 0;  // Kerätyt rahat, jotka pelaaja saa, jos voittaa
    
    private bool tavoiteSaavutettu = false;
    private bool peliOhi = false;
    private double tavoiteRaha = 1000000000;
    private double tempscore;
    private double highScore = 0;
    private double finalscore;
    private bool AloitusRaha = false;
    private Timer aikaLaskuri;
    private double lopetusAika;
    private EasyHighScore topLista = new ("toplistsave.txt", 10, "-");

    private bool voitto;
    
    private int pelaajanSumma;
    private int jakajanSumma;

    int aCountP = 0;
    int aCountD = 0;
    
    private bool bjDoubled = false;

    private Label bjVaihtoehdot;
    private Label pelaajanSummalab;
    
    public List<RouletteBet> CreateRouletteBets()
{
    var rulettitaskut = new List<RouletteBet>();
    
    string[] pockets = new string[] { 
        "6", "27", "13", "36", "11", "30", "8", "23", "10", "5", "00", "24", "16", "33", "1", "20", "14", "31", "9", "22",
        "18", "29", "7", "28", "12", "35", "3", "26", "0", "32", "15", "19", "4", "21", "2", "25", "17", "34" 
    };

    // Värit: Vihreät 0 ja 00, muut ovat virallisesti määrättyjä.
    // Muut värit on asetettu siten, että annettu järjestys vastaa virallista ruletin väriä.
    string[] colors = new string[] {
        "Black", "Red", "Black", "Red", "Black", "Red", "Black", "Red", "Black", "Red", "Green",    
        "Black", "Red", "Black", "Red", "Black", "Red", "Black", "Red", "Black", "Red", "Black", "Red", "Black", "Red", "Black", "Red", "Black", "Green",    
        "Red", "Black", "Red", "Black", "Red", "Black", "Red", "Black", "Red"
    };

    double[] anglet = new double[] {
        349.19, 343.59, 335.44, 328.59, 315.09, 305.46, 295.42, 286.78, 280.64, 273.02, 263.29,      
        252.19, 236.73, 226.1, 211.09, 199.93, 188.91, 180.07, 173.39, 167.78, 154.57, 144.36, 133.26, 128.32, 120.23, 109.88, 99.42, 89.6, 84.32,
        78.91, 67.66, 57.39, 43.43, 33.12, 27.18, 20.23, 10.44, 0.0
    };

    for (int i = 0; i < pockets.Length; i++)
    {
        string name = pockets[i];
        string color = colors[i];
        double angle = anglet[i];
        rulettitaskut.Add(new RouletteBet(name, color, angle));  
    }
    
    return rulettitaskut;
}

    private string[] Suits = {"Hertta", "Ruutu", "Risti", "Pata" };
    private string[] Ranks = { "2", "3", "4", "5", "6", "7", "8", "9", "10", "J", "Q", "K", "A" };
    
    private Image[] coinFlipImages = LoadImages( "coin1", "coin2", "coin3", "coin4", "coin5", "coin6", "coin7", "coin8" );
    
    public override void Begin() // pelin alku
    {
        IsFullScreen = true;
        Level.Size = Screen.Size;
        Camera.ZoomToLevel();
        Valikko();
    }

    public void Valikko() // lore
    {//santeri tekee tähän loren  vv
        Label titleLabel = new Label("Poikasi on kaapattu ja venäläinen mafia tulee pian perimään lunnaita.")
        {
            Color = Color.White,
            Position = new Vector(0, 150), // Asetetaan sijainti
        };
        Add(titleLabel);
        MultiSelectWindow alkuValikko = new MultiSelectWindow("Mitä haluat tehdä?",
            "Ota pankista 1000€ laina ja mene kasinolle", "Luovuta elämässä...");
        //alkuValikko.MakeStatic();
        Add(alkuValikko);
        alkuValikko.AddItemHandler(0, AloitaPeli);
        alkuValikko.AddItemHandler(1, Exit);
    }
    
    public void AloitaPeli() // aloittaa varsinaisen kasinon
    {
        ClearAll();
        MessageDisplay.MaxMessageCount = 3;
        MessageDisplay.MessageTime = new TimeSpan(0, 0, 3);
        pistelaskuri = new DoubleMeter(0);
        pistenaytto = new Label();
        pistelaskuri.Value += 1000;
        AloitusRaha = true;
        
        topLista.EnterText = "Onnittelut, olet päässyt kymmenen parhaimman uhkapelaajan joukkoon! Syötä nimesi niin jäät historian kirjoihin.";
        topLista.Text = "Parhaat uhkapelaajat";
        topLista.HighScoreWindow.Size = new Vector(300,400);
        topLista.HighScoreWindow.Color = Color.Mint;
        
        LuoAikaLaskuri();
        LuoPistelaskuri();
        PelinValinta();
        
    }

    private void LuoAikaLaskuri()
    {
        aikaLaskuri = new Timer();
        aikaLaskuri.Start();
    }

    void LuoPistelaskuri() //luo pistelaskurin rahalle
    {
        pistenaytto.X = 0 ;
        pistenaytto.Y = Level.Top - 25;
        pistenaytto.TextScale = new Vector(2, 2); 
        pistenaytto.TextColor = Color.Lime;
        pistenaytto.Color = Color.Transparent;
        pistenaytto.BorderColor = Color.Gold;
        pistenaytto.Title = "Rahaa: ";
        pistenaytto.BindTo(pistelaskuri);
        Add(pistenaytto);
        
        //surullinen yritys progressbarille
        ProgressBar goal = new ProgressBar(150, 10);
        goal.BindTo(pistelaskuri);
        goal.X = Screen.Left + 150;
        goal.Y = Screen.Top - 20;
        goal.BarColor = Color.Green;
        goal.BorderColor = Color.Gold;
        Add(goal);
        
        pistelaskuri.MaxValue = tavoiteRaha;
    }

    protected override void Update(Time time) //chekkailee missä mennään rahojen suhteen
    {
        base.Update(time);

        // Tarkista, onko tavoite saavutettu
        TarkistaRahaTavoite();
        TarkistaScore();
    }
    
    private void TarkistaRahaTavoite()
    {
        if (pistelaskuri == null) return;
        //Console.WriteLine("päästiin nullin läpi mennään if lauseeseen pelejä kesken: "+peliKesken);
        
        
        
        // Tarkista vain, jos tavoitetta ei ole jo saavutettu
        if (pistelaskuri.Value >= tavoiteRaha && !tavoiteSaavutettu)
        {
            tavoiteSaavutettu = true;
            MessageDisplay.Add("Tavoite saavutettu!");
            LaskeScore();
            Voitto();
        }

        else if (peliKesken == 0 && pistelaskuri.Value == 0 && !peliOhi)
        {
            //Console.WriteLine("päästiin loppuun rahat nollassa ja avataan defeat");
            peliOhi = true;
            MessageDisplay.Add("Luuseri");
            ClearAll();
            LaskeScore();
            Defeat();
        }
        //Console.WriteLine("päästiin defeatin ohi mitään ei tapahtunut");
    }

    private void TarkistaScore()
    {
        if (peliKesken == 0)
        {
            if (pistelaskuri == null) return;
            else if (pistelaskuri.Value > tempscore)
            {
                highScore += (pistelaskuri.Value-tempscore);
                Console.WriteLine("uusi highscore: "+highScore);
                tempscore = pistelaskuri.Value;
            }
            else
            {
                tempscore = pistelaskuri.Value;
            }
        }
        else
        {
            return;
        }
    }

    private void LaskeScore()
    {
        lopetusAika = aikaLaskuri.SecondCounter.Value;
        Console.WriteLine("lopetusaika on "+aikaLaskuri.SecondCounter.Value);
        finalscore = Math.Round((highScore-1000)/(lopetusAika/10), 0);
        Console.WriteLine(highScore+"-1000 on "+ (highScore-1000)+" ja se jaetaan "+lopetusAika+" tulee "+((highScore-1000)/lopetusAika));
        Console.WriteLine("finalscore: "+finalscore);
    }
    
    
    //kuvien lataus
    Image taustakuvaPV = LoadImage("kasinoLobby.jpg");
    Image taustakuvaBJ = LoadImage("taustakuvaBJ.jpg");
    Image taustakuvaPlinko = LoadImage("plinkobg.jpg");
    Image taustakuvaCF = LoadImage("Coinflipbg.png");
    Image taustakuvaRulet = LoadImage("RouletteBG.png");
    Image Icon1 = LoadImage("Plinko.jpg");
    Image Icon2 = LoadImage("Blackjack.png");
    Image Icon3 = LoadImage("Ruletti.png"); 
    Image Icon4 = LoadImage("Slots.jpg");
    Image Icon5 = LoadImage("Coinflip.png");

    /// <summary>
    /// Pelin "aloitusruutuu" jossa valitaan mitä peliä halutaan pelata.
    /// </summary>
    void PelinValinta()
    {
        Gravity = new Vector(0, 0);
        
        Level.Background.Image = taustakuvaPV;
        Level.Background.FitToLevel();
        LuoPistelaskuri();
        var pakka = LuoPakka();
        SekoitaPakka(pakka);     

        MiniPeliLogo(this,250, 325,  - 400, Level.Top - 300, "Plinko", 1);
        MiniPeliLogo(this,250, 325, 0, Level.Top - 300, "Blackjack", 2);
        MiniPeliLogo(this,250, 325, 400, Level.Top - 300, "Ruletti", 3);
        MiniPeliLogo(this,250,325, -400, -200, "Slots", 4);
        MiniPeliLogo(this,250,325, 0, -200, "Coinflip", 5);
        Keyboard.Listen(Key.Space, ButtonState.Down, AddRaha, "antaa rahaa");
        Keyboard.Listen(Key.D2, ButtonState.Pressed, async () => await BlackJack(), "Menee peliin BlackJack");
        Keyboard.Listen(Key.D1, ButtonState.Pressed, async () => await Plinko(), "Menee peliin Plinko");
        Keyboard.Listen(Key.D3, ButtonState.Pressed, async () => await Ruletti(), "Menee peliin Ruletti");
        Keyboard.Listen(Key.D4, ButtonState.Pressed, async () => await Slots(), "Menee peliin Slots");
        Keyboard.Listen(Key.D5, ButtonState.Pressed, async () => await Coinflip(), "Menee peliin Coinflip");
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, Exit, "Lopeta peli");
        
    }
    
    
    /// <summary>
    /// Blackjack peli, panosken asetus, peli ja tulosten lasku
    /// </summary>
    public async Task BlackJack()
    {
        panosAsetettu = new TaskCompletionSource<bool>(false);  // Alustetaan uudelleen jokaiselle kierrokselle

        Level.Background.Image = taustakuvaBJ;
        ClearGameObjects();
        ClearControls();
        Remove(pistenaytto);
        Add(pistenaytto);
        await LisaaPanos();  // Odotetaan, kunnes panos on asetettu

        panosAsetettu.TrySetResult(true);  // Varmistetaan, että odotus päättyy 
        TakaisinPV();
        // Poistetaan "Aseta panos" -teksti
        ClearControls();
        EnsimmäinenBJ();
    }
    
    public async Task LisaaPanos()
    {
        // Ylhäällä keskellä oleva teksti "Aseta panos"
        Label titleLabel = new Label("Aseta panos")
        {
            Color = Color.White,
            Position = new Vector(0, 200), // Asetetaan sijainti
        };
        Add(titleLabel);

        // Rahasumma label
        panosLabel = new Label("Panos: " + Math.Round(panos ,2))
        {
            Color = Color.White,
            Position = new Vector(0,150), // Asetetaan sijainti
            TextScale = new Vector(2, 2)
        };
        Add(panosLabel);
        InputWindow kysymysIkkuna = new InputWindow("Aseta Panos" );
        kysymysIkkuna.TextEntered += ProcessInput;
        Add( kysymysIkkuna );
        await panosAsetettu.Task;
        Remove(titleLabel);
    }


    public async Task EnsimmäinenBJ()
    {
        ClearGameObjects();
        ClearControls();
        Add(pistenaytto);
        Add(panosLabel);

        if (pistelaskuri.Value < panos)
        {
            MessageDisplay.Add("Ei tarpeeksi rahaa pelata");
            PelinValinta();
            return;
        }
        
        bjDoubled = false;
        
        List<Card> pelaajanKortit = new List<Card>();
        List<Card> jakajanKortit = new List<Card>();
        panosLabel.Position = new Vector(0, Level.Bottom + 40);
        
        foreach (var card in pakka)
        {
            Console.WriteLine(card);
        }

        pelaajanKortit = JaaKortit(pakka, 2);
        this.pelaajanKortit = pelaajanKortit;
        
        jakajanKortit = JaaKortit(pakka, 2);
        this.jakajanKortit = jakajanKortit;

        peliKesken += 1;
        pistelaskuri.Value -= panos;
        
        int korttiLeveys = 150; // Oletetaan, että kortin leveys on 100 yksikköä
        int xOffset = 50; // Etäisyys korttien välillä
        int startX = 0; // Alkuperäinen X-sijainti

        double positionX;
        double positionY;
        
        Card kortti;
        Image kortinKuva;
        for (int i = 0; i < pelaajanKortit.Count; i++)
        {
            kortti = pelaajanKortit[i];
            kortinKuva = LoadImage(kortti.ToString());
            
            // Lasketaan kortin sijainti
            positionX = startX + i * (korttiLeveys + xOffset);
            positionY = -260;

            await Task.Delay(200);
            // Lisätään kortti peliin
            Add(new PhysicsObject(korttiLeveys, korttiLeveys*1.5, Shape.Rectangle)
            {
                Image = kortinKuva,
                Position = new Vector(positionX, positionY)
            });
        }

        aCountD = 0;
        aCountP = 0;
        pelaajanSumma = 0;
        jakajanSumma = 0;
        foreach (var card in this.pelaajanKortit)
        {
            Console.WriteLine("pelaajan kortti: "+card);
            if (card.BjCardValue == 11) aCountP++; // Lasketaan ässät
            pelaajanSumma += card.BjCardValue;
        }
        Console.WriteLine(pelaajanSumma);
        foreach (var card in jakajanKortit)
        {
            Console.WriteLine("jakajan kortti: "+card);
            if (card.BjCardValue == 11) aCountD++; // Lasketaan ässät
            jakajanSumma += card.BjCardValue;
        }
        
        while (pelaajanSumma > 21 && aCountP > 0)
        {
            pelaajanSumma -= 10; // Vaihdetaan ässän arvo 1:ksi
            aCountP--;
        }
        while (jakajanSumma > 21 && aCountD > 0)
        {
            jakajanSumma -= 10; // Vaihdetaan ässän arvo 1:ksi
            aCountD--;
        }
        
        kortti = jakajanKortit[0];
        kortinKuva = LoadImage(kortti.ToString());

        // Lasketaan kortin sijainti
        positionX = startX + 0 * (korttiLeveys + xOffset);
        double positionYjak = 225;
        
        await Task.Delay(300);
        // Lisätään kortti peliin
        Add(new PhysicsObject(korttiLeveys, 225, Shape.Rectangle)
        {
            Image = kortinKuva,
            Position = new Vector(positionX, positionYjak)
        });
        await Task.Delay(500);

        
        Console.WriteLine("kortteja pakasssa "+pakka.Count);
        
        if (pelaajanKortit[0].BjCardValue + pelaajanKortit[1].BjCardValue == 21) //Jos pelaaja saa suoraan 21
        {
            pistelaskuri.Value += 2 * panos * yTs;
            Label instabj = new Label("Sait juuri suoraan 21 eli voitit tämän kierroksen.")
            {
                Color = Color.White,
                Position = new Vector(0,-75), // Asetetaan sijainti
            };
            Add(instabj);
            Label uusi = new Label("Haluatko aloittaa uuden kierroksen samalla panoksella (n), vaihtaa panosta (p) vai poistua pelistä (0)?")
            {
                Color = Color.White,
                Position = new Vector(0, -100), // Asetetaan sijainti
            };
            Add(uusi);
            peliKesken -= 1;
            Keyboard.Listen(Key.P, ButtonState.Pressed, async () => await BlackJack(), "uus kiesi uudella panoksella"); // MUUTA MYÖHEMMIN KOSKA UUSI KIESI LUO UUDEN PAKAN
            Keyboard.Listen(Key.N, ButtonState.Pressed, async () => await EnsimmäinenBJ(), "uus kiesi");
            TakaisinPV();
        }
        
        else if (jakajanKortit[0].BjCardValue + jakajanKortit[1].BjCardValue == 21) //jos jakaja saa suoraan 21 mutta pelaaja ei saa
        {
            kortti = jakajanKortit[1];
            kortinKuva = LoadImage(kortti.ToString());

            // Lasketaan kortin sijainti
            positionX = startX + 0 * (korttiLeveys + xOffset);
            positionYjak = 225;

            
            await Task.Delay(300);
            // Lisätään kortti peliin
            Add(new PhysicsObject(korttiLeveys, 225, Shape.Rectangle)
            {
                Image = kortinKuva,
                Position = new Vector(positionX, positionYjak)
            });
            await Task.Delay(500);
            
            Label instabj = new Label("Voi ei!!! Nyt kävi huono tuuri. Jakaja kurkisti peiliinsä ja näki että hänellä onkin suoraan 21. Eli jakaja voitti pelin")
            {
                Color = Color.White,
                Position = new Vector(0,-75), // Asetetaan sijainti
            };
            Add(instabj);
            Label uusi = new Label("Haluatko aloittaa uuden kierroksen samalla panoksella (n), vaihtaa panosta (p) vai poistua pelistä (0)?")
            {
                Color = Color.White,
                Position = new Vector(0, -100), // Asetetaan sijainti
            };
            Add(uusi);
            peliKesken -= 1;
            Keyboard.Listen(Key.P, ButtonState.Pressed, async () => await BlackJack(), "uus kiesi uudella panoksella"); // MUUTA MYÖHEMMIN KOSKA UUSI KIESI LUO UUDEN PAKAN
            Keyboard.Listen(Key.N, ButtonState.Pressed, async () => await EnsimmäinenBJ(), "uus kiesi");
            TakaisinPV();

        }

        else //jakajalla eikä pelaajalla 21 suoraan peli jatkuu
        {
            pelaajanSummalab = new Label("Sinulla on "+ pelaajanSumma +" ja jakajalla on "+jakajanKortit[0].BjCardValue)
            {
                Color = Color.White,
                Position = new Vector(0,-50), // Asetetaan sijainti
            };
            Add(pelaajanSummalab);
            
            //if (pelaajanKortit[0]==pelaajanKortit[1] && pistelaskuri>=panos) //Split ja doubleDown
            //{
                //Label bjVaihtoehdot = new Label("Haluatko ottaa vielä kortin (h), tuplata panoksen ja ottaa viimeisen kortin (d) vai pysyä tässä (s)?")
                //{
                    //Color = Color.White,
                    //Position = new Vector(0,-75), // Asetetaan sijainti
                //};
                //Add(bjVaihtoehdot);
                //Keyboard.Listen(Key.H, ButtonState.Pressed, DoubleDown, "Ottaa vielä yhden kortin ja tuplaa panoksen");
                
            //}
            
            //else if (pelaajanKortit[0]==pelaajanKortit[1]) //Split
            //{
                //Label bjVaihtoehdot = new Label("Haluatko  ottaa vielä kortin (h), tuplata panoksen ja ottaa viimeisen kortin (d), splitata kaksi samaa korttia ja pelata kaksi kättä (y) vai pysyä tässä (s)?")
                //{
                    //Color = Color.White,
                    //Position = new Vector(0,-75), // Asetetaan sijainti
                //};
                //Add(bjVaihtoehdot);
                //Keyboard.Listen(Key.H, ButtonState.Pressed, DoubleDown, "Ottaa vielä yhden kortin ja tuplaa panoksen");
            //}
            
            if(pistelaskuri>= panos) //DoubleDown mahdollisuus
            {
                bjVaihtoehdot = new Label("Haluatko  ottaa vielä kortin (h), tuplata panoksen ja ottaa viimeisen kortin (d) vai pysyä tässä (s)?")
                {
                    Color = Color.White,
                    Position = new Vector(0,-75), // Asetetaan sijainti
                };
                Add(bjVaihtoehdot);
                Keyboard.Listen(Key.D, ButtonState.Pressed, async () => await DoubleDown(bjVaihtoehdot, pelaajanSummalab), "Ottaa vielä yhden kortin ja tuplaa panoksen");
            }

            else
            { 
                bjVaihtoehdot = new Label("Haluatko  ottaa vielä kortin (h) vai pysyä tässä (s)?")
                {
                    Color = Color.White,
                    Position = new Vector(0,-75), // Asetetaan sijainti
                };
                Add(bjVaihtoehdot);
            }
            
            
            Keyboard.Listen(Key.S, ButtonState.Pressed, async () => await PysyTassa(bjVaihtoehdot, pelaajanSummalab), "Pysyy tässä");
            Keyboard.Listen(Key.H, ButtonState.Pressed, async () => await OtaKortti(bjVaihtoehdot, pelaajanSummalab), "Ottaa vielä kortin");
            
        }
    }
    
    public async Task OtaKortti(Label bjV, Label sum)
    {
        ClearControls();
        Remove(bjV);
        Remove(sum);
        TakaisinPV();
        aCountP = 0;
        aCountD = 0;
        
        int korttiLeveys = 150; // Oletetaan, että kortin leveys on 100 yksikköä
        int xOffset = 50; // Etäisyys korttien välillä
        int startX = 0; // Alkuperäinen X-sijainti

        double positionX;
        double positionY = 225;
        double positionYjak = -260;

        int pelaajanSumma = 0;
        int jakajanSumma = 0;
        
        Card kortti;
        Image kortinKuva;
        List<Card> uudetKortit = JaaKortit(pakka, 1);
        kortti = uudetKortit[0];
        kortinKuva = LoadImage(kortti.ToString());

        // Lasketaan kortin sijainti
        positionX = startX + 0 * (korttiLeveys + xOffset);
        
        await Task.Delay(300);
        // Lisätään kortti peliin
        Add(new PhysicsObject(korttiLeveys, 225, Shape.Rectangle)
        {
            Image = kortinKuva,
            Position = new Vector(positionX, positionYjak)
        });
        await Task.Delay(500);
        
        pelaajanKortit.Add(uudetKortit[0]);
        pelaajanSumma = 0;
        foreach (var card in pelaajanKortit) // laskee summat ja ässät
        {
            Console.WriteLine("pelaajankortti "+card);
            if (card.BjCardValue == 11)
            {
                aCountP++;
            }
            pelaajanSumma += card.BjCardValue;
            Console.WriteLine("pelaajansumma "+pelaajanSumma);
        }
        Console.WriteLine("pelaajansumma final "+pelaajanSumma);
        Console.WriteLine("Ässiä "+aCountP+aCountD);
        
        foreach (var card in jakajanKortit)
        {
            Console.WriteLine("jakajan kortti: "+card);
            if (card.BjCardValue == 11) aCountD++; // Lasketaan ässät
            jakajanSumma += card.BjCardValue;
        }
        
        //laskee ässät pois
        while (pelaajanSumma > 21 && aCountP > 0)
        {
            pelaajanSumma -= 10;
            aCountP--;
        }
        
        while (jakajanSumma > 21 && aCountD > 0)
        {
            pelaajanSumma -= 10;
            aCountD--;
        }
        
        
        //kattoo insta 21
        if (pelaajanSumma != 21)
        {
            pelaajanSummalab = new Label("Sinulla on "+ pelaajanSumma +" ja jakajalla on "+jakajanKortit[0].BjCardValue)
            {
                Color = Color.White,
                Position = new Vector(0,-45), // Asetetaan sijainti
            };
            Add(pelaajanSummalab);
        }
        
        if (pelaajanSumma == 21)
        {
            await DealerFinish(pelaajanSummalab);
        }

        else if (pelaajanSumma < 21 && pistelaskuri >= panos)
        {
            Label bjVaihtoehdot2 = new Label("Haluatko  ottaa vielä kortin (h), tuplata panoksen ja ottaa viimeisen kortin (d) vai pysyä tässä (s)?")
                {
                    Color = Color.White,
                    Position = new Vector(0, -75), // Asetetaan sijainti
                };
            Add(bjVaihtoehdot2);
            Keyboard.Listen(Key.S, ButtonState.Pressed, async () => await PysyTassa(bjVaihtoehdot2, pelaajanSummalab), "Pysyy tässä");
            Keyboard.Listen(Key.H, ButtonState.Pressed, async () => await OtaKortti(bjVaihtoehdot2, pelaajanSummalab), "Ottaa vielä kortin");
            Keyboard.Listen(Key.D, ButtonState.Pressed, async () => await DoubleDown(bjVaihtoehdot2, pelaajanSummalab), "Ottaa vielä yhden kortin ja tuplaa panoksen");
        }

        else if (pelaajanSumma < 21)
        {
            Label bjVaihtoehdot3 = new Label("Haluatko  ottaa vielä kortin (h) vai pysyä tässä (s)?")
            {
                Color = Color.White,
                Position = new Vector(0, -75), // Asetetaan sijainti
            };
            Add(bjVaihtoehdot3);
            Keyboard.Listen(Key.S, ButtonState.Pressed, async () => await PysyTassa(bjVaihtoehdot3, pelaajanSummalab), "Pysyy tässä");
            Keyboard.Listen(Key.H, ButtonState.Pressed, async () => await OtaKortti(bjVaihtoehdot3, pelaajanSummalab), "Ottaa vielä kortin");
        }

        else
        {
            ClearControls();
            Label Bust = new Label("Nyt meni yli 21 ja hävisit kierroksen, Haluatko aloittaa uuden kierroksen samalla panoksella (n), vaihtaa panosta (p) vai poistua pelistä (0)?")
            {
                Color = Color.White,
                Position = new Vector(0, -100), // Asetetaan sijainti
            };
            Add(Bust);
            peliKesken -= 1;
            Keyboard.Listen(Key.P, ButtonState.Pressed, async () => await BlackJack(), "uus kiesi uudella panoksella"); // MUUTA MYÖHEMMIN KOSKA UUSI KIESI LUO UUDEN PAKAN
            Keyboard.Listen(Key.N, ButtonState.Pressed, async () => await EnsimmäinenBJ(), "uus kiesi");
            TakaisinPV();
        }
        
    }
    
    // voit ottaa vielä viimeisen kortin ja tuplata panoksen, sen jälkeen et voi tehdä enää mitääm
    public async Task DoubleDown(Label bjV, Label sum) 
    {
        Remove(bjV);
        Remove(sum);
        ClearControls();
        TakaisinPV();
        Console.WriteLine("panos "+panos);
        pistelaskuri.Value -= panos;
        bjDoubled = true;
        aCountD = 0;
        aCountP = 0;
        
        int korttiLeveys = 150; // Oletetaan, että kortin leveys on 100 yksikköä
        int xOffset = 50; // Etäisyys korttien välillä
        int startX = 0; // Alkuperäinen X-sijainti

        double positionX;
        
        Card kortti;
        Image kortinKuva;
        List<Card> uudetKortit = JaaKortit(pakka, 1);
        kortti = uudetKortit[0];
        kortinKuva = LoadImage(kortti.ToString());

        // Lasketaan kortin sijainti
        positionX = startX + 0 * (korttiLeveys + xOffset);
        double positionYjak = -260;

        await Task.Delay(300);
        // Lisätään kortti peliin
        Add(new PhysicsObject(korttiLeveys, 225, Shape.Rectangle)
        {
            Image = kortinKuva,
            Position = new Vector(positionX, positionYjak)
        });
        await Task.Delay(500);
        
        pelaajanKortit.Add(uudetKortit[0]);
        pelaajanSumma = 0;
        jakajanSumma = 0;
        foreach (var card in pelaajanKortit)
        {
            Console.WriteLine("pelaajankortti "+card);
            if (card.BjCardValue == 11) aCountP++; // Lasketaan ässät
            pelaajanSumma += card.BjCardValue;
        }
        Console.WriteLine("pelaajansumma final "+pelaajanSumma);
        foreach (var card in jakajanKortit)
        {
            Console.WriteLine("jakajan kortti: "+card);
            if (card.BjCardValue == 11) aCountD++; // Lasketaan ässät
            jakajanSumma += card.BjCardValue;
        }
        while (pelaajanSumma > 21 && aCountP > 0)
        {
            pelaajanSumma -= 10;
            aCountP--;
        }

        var pelaajanSummalab = new Label("")
        {
            Color = Color.White, Position = new Vector(0, -50), // Asetetaan sijainti
        };
        Add(pelaajanSummalab);

        // Lasketaan kortin sijainti
        positionX = startX + 0 * (korttiLeveys + xOffset);
        positionYjak = 225;

        kortti = jakajanKortit[1];
        kortinKuva = LoadImage(kortti.ToString());

        // Lasketaan kortin sijainti
        positionX = startX + 0 * (korttiLeveys + xOffset);

        
        await Task.Delay(300);
        // Lisätään kortti peliin
        Add(new PhysicsObject(korttiLeveys, 225, Shape.Rectangle)
        {
            Image = kortinKuva,
            Position = new Vector(positionX, positionYjak)
        });
        await Task.Delay(500);

        if (pelaajanSumma > 21)
        {
            ClearControls();
            Label Bust = new Label("Nyt meni yli 21 ja hävisit kierroksen, Haluatko aloittaa uuden kierroksen samalla panoksella (n), vaihtaa panosta (p) vai poistua pelistä (0)?")
            {
                Color = Color.White,
                Position = new Vector(0, -100), // Asetetaan sijainti
            };
            Add(Bust);
            peliKesken -= 1;
            Keyboard.Listen(Key.P, ButtonState.Pressed, async () => await BlackJack(), "uus kiesi uudella panoksella"); // MUUTA MYÖHEMMIN KOSKA UUSI KIESI LUO UUDEN PAKAN
            Keyboard.Listen(Key.N, ButtonState.Pressed, async () => await EnsimmäinenBJ(), "uus kiesi");
            TakaisinPV();
        }
        
        else DealerFinish(pelaajanSummalab);
    }
    
    public async Task PysyTassa(Label bjV, Label sum) // olet tyytyväinen kortteihin
    {
        Remove(bjV);
        Remove(sum);
        ClearControls();
        TakaisinPV();
        
        int korttiLeveys = 150; // Oletetaan, että kortin leveys on 100 yksikköä
        int xOffset = 50; // Etäisyys korttien välillä
        int startX = 0; // Alkuperäinen X-sijainti

        double positionX;
        // Lasketaan kortin sijainti

        pelaajanSumma = 0;
        jakajanSumma = 0;
        
        Card kortti;
        Image kortinKuva;
        
        kortti = jakajanKortit[1];
        kortinKuva = LoadImage(kortti.ToString());

        // Lasketaan kortin sijainti
        positionX = startX + 0 * (korttiLeveys + xOffset);
        double positionYjak = 225;

        
        await Task.Delay(300);
        // Lisätään kortti peliin
        Add(new PhysicsObject(korttiLeveys, 225, Shape.Rectangle)
        {
            Image = kortinKuva,
            Position = new Vector(positionX, positionYjak)
        });
        await Task.Delay(500);
        
        aCountP = 0;
        aCountD = 0;
        
        foreach (var card in pelaajanKortit)
        {
            Console.WriteLine("pelaajankortti "+card);
            pelaajanSumma += card.BjCardValue;
            if (card.BjCardValue == 11) aCountP++; // Lasketaan ässät 
        }
        Console.WriteLine("pelaajansumma final "+pelaajanSumma);
        foreach (var card in jakajanKortit)
        {
            Console.WriteLine("jakajan kortti: "+card);
            if (card.BjCardValue == 11) aCountD++; // Lasketaan ässät 
            jakajanSumma += card.BjCardValue;
        }
        
        DealerFinish(pelaajanSummalab);
        
    }


    public async Task DealerFinish(Label sum) // lopettaa pelin jakajan vuoroon
    {
        Remove(sum);
        Card kortti;
        Image kortinKuva;
        int korttiLeveys = 150; // Oletetaan, että kortin leveys on 100 yksikköä
        int xOffset = 50; // Etäisyys korttien välillä
        int startX = 0; // Alkuperäinen X-sijainti

        double positionX;
        
        while (jakajanSumma < 17)
        {
            List<Card> uudetKortit = JaaKortit(pakka, 1);
            kortti = uudetKortit[0];
            kortinKuva = LoadImage(kortti.ToString());
            
            // Lasketaan kortin sijainti
            positionX = startX + 0 * (korttiLeveys + xOffset);
            double positionYjak = 225;
            
            
            await Task.Delay(300);
            Add(new PhysicsObject(korttiLeveys, 225, Shape.Rectangle)
            {
                Image = kortinKuva,
                Position = new Vector(positionX, positionYjak)
            });
            await Task.Delay(500);
            
            jakajanKortit.Add(uudetKortit[0]);
            jakajanSumma = 0;
            aCountD = 0;
            foreach (var card in jakajanKortit)
            {
                Console.WriteLine("jakajankortti "+card);
                if (card.BjCardValue == 11)
                {
                    aCountD++;
                }
                jakajanSumma += card.BjCardValue;
            }
            Console.WriteLine("jakajan summa on  "+jakajanSumma);
            Console.WriteLine("Ässiä "+aCountD);
            
            // Ässien arvojen säätö jakajan summan ylittäessä 21
            Console.WriteLine("Ennen ässien säätöä: jakajanSumma = " + jakajanSumma);
            while (jakajanSumma > 21 && aCountD > 0)
            {
                jakajanSumma -= 10;
                aCountD--;
            }
            Console.WriteLine("Ässien säädön jälkeen: jakajanSumma = " + jakajanSumma);
            
        }

        pelaajanSumma = 0;
        aCountP = 0;
        
        foreach (var card in pelaajanKortit)
        {
            Console.WriteLine("pelaajankortti "+card);
            pelaajanSumma += card.BjCardValue;
            if (card.BjCardValue == 11)
            {
                aCountP++;
            }
        }
        Console.WriteLine("pelaajansumma laskennan jälkeen Ennen ässien säätöä: pelaajanSumma = " + pelaajanSumma);
        while (pelaajanSumma > 21 && aCountP > 0)
        {
            pelaajanSumma -= 10;
            aCountP--;
        }
        Console.WriteLine("Ässien säädön jälkeen: pelaajanSumma = " + pelaajanSumma);
        
        pelaajanSummalab = new Label("Sinulla on "+ pelaajanSumma +" ja jakajalla on "+jakajanSumma)
        {
            Color = Color.White,
            Position = new Vector(0,-45), // Asetetaan sijainti
        };
        Add(pelaajanSummalab);
        
        
        Console.WriteLine("pelaajalla on "+pelaajanSumma+" ja jakajalla on "+jakajanSumma);

        if (pelaajanSumma == 21 && jakajanSumma != 21)              
        {
            Label tulosLabel = new Label("Sait 21 ja voitit kierroksen!!")
            {
                Color = Color.White,
                Position = new Vector(0, -75), // Asetetaan sijainti
            };
            Add(tulosLabel);
            pistelaskuri.Value += 2 * panos * yTs;
            if (bjDoubled)
            {
                pistelaskuri.Value += 2 * panos * yTs;
                bjDoubled = false;
            }
            
            endScreenBJ();
        }
        
        else if (pelaajanSumma > 21)
        {
            Label tulosLabel = new Label("Sinulla meni yli 21, Hävisit kierroksen.")
            {
                Color = Color.White,
                Position = new Vector(0, -75), // Asetetaan sijainti
            };
            Add(tulosLabel);
            endScreenBJ();
        }
        
        else if (jakajanSumma == pelaajanSumma)
        {
            Label tulosLabel = new Label("Tasapeli eli saat panoksesi takaisin")
            {
                Color = Color.White,
                Position = new Vector(0, -75), // Asetetaan sijainti
            };
            Add(tulosLabel);
            pistelaskuri.Value += panos * yTs;
            if (bjDoubled)
            {
                pistelaskuri.Value += panos * yTs;
                bjDoubled = false;
            }
            endScreenBJ();
        }
        
        else if (jakajanSumma < pelaajanSumma && pelaajanSumma <= 21)
        {
            Label tulosLabel = new Label("Voitit kierroksen!!")
            {
                Color = Color.White,
                Position = new Vector(0, -75), // Asetetaan sijainti
            };
            Add(tulosLabel);
            pistelaskuri.Value += 2 * panos * yTs;
            if (bjDoubled)
            {
                pistelaskuri.Value += 2 * panos * yTs;
                bjDoubled = false;
            }
            endScreenBJ();
        }

        else if (pelaajanSumma < jakajanSumma && jakajanSumma <= 21)
        {
            Label tulosLabel = new Label("Hävisit kierroksen")
            {
                Color = Color.White,
                Position = new Vector(0, -75), // Asetetaan sijainti
            };
            Add(tulosLabel);
            endScreenBJ();
        }
        else if (pelaajanSumma <= 21 && jakajanSumma > 21)
        {
            Label tulosLabel = new Label("Voitit kierroksen!! Jakaja meni yli 21.")
            {
                Color = Color.White,
                Position = new Vector(0, -75), // Asetetaan sijainti
            };
            Add(tulosLabel);
            pistelaskuri.Value += 2 * panos * yTs;
            if (bjDoubled)
            {
                pistelaskuri.Value += 2 * panos * yTs;
                bjDoubled = false;
            }

            endScreenBJ();

        }

        TakaisinPV();
    }

    public void endScreenBJ()
    {
        Label uusi = new Label("Haluatko aloittaa uuden kierroksen samalla panoksella (n), vaihtaa panosta (p) vai poistua pelistä (0)?")
        {
            Color = Color.White,
            Position = new Vector(0, -105), // Asetetaan sijainti
        };
        Add(uusi);
        peliKesken -= 1;
        Keyboard.Listen(Key.P, ButtonState.Pressed, async () => await BlackJack(), "uus kiesi uudella panoksella"); // MUUTA MYÖHEMMIN KOSKA UUSI KIESI LUO UUDEN PAKAN
        Keyboard.Listen(Key.N, ButtonState.Pressed, async () => await EnsimmäinenBJ(), "uus kiesi");
        TakaisinPV();
    }
    
    // Luo korttipakka
    public List<Card> LuoPakka() // luo korttipakan no shit sherlock
    {
        //var pakka = new List<Card>();
        pakka.Clear();
        foreach (var suit in Suits)
        {
            foreach (var rank in Ranks)
            {
                pakka.Add(new Card(suit, rank));
            }
        }
        return pakka;
    }
        
    
    //sekoittaa pakan
    public void SekoitaPakka(List<Card> pakka) // oisko vaikka että sekoittaa pakan
    {
        Random rand = new Random();
        int n = pakka.Count;

        while (n > 1)
        { 
            int k = rand.Next(n--);
            var temp = pakka[n]; 
            pakka[n] = pakka[k];
            pakka[k] = temp;
        }
    }
    public List<Card> JaaKortit(List<Card> pakka, int korttienMaara) // kenties jakaa kortit
    {
        var jaetutKortit = new List<Card>();
        Random random = new Random();
        while (jaetutKortit.Count < korttienMaara)
        {
            if (pakka.Count == 0) // Tarkistetaan, onko pakka tyhjentynyt
            {
                pakka = LuoPakka(); // Luo uusi pakka
                SekoitaPakka(pakka); // Sekoita uusi pakka
            }

            int index = random.Next(pakka.Count);
            jaetutKortit.Add(pakka[index]);
            pakka.RemoveAt(index); // Poistaa kortin pakasta
        }
        return jaetutKortit;
    }
    
    public async Task VaihdaPanos() // hmmmmmm voisiko ehkä vaihtaa panosta
    { //esim plinkossa voi vaihtaa panosta lennosta
        InputWindow kysymysIkkuna = new InputWindow("Aseta Panos" );
        kysymysIkkuna.TextEntered += ProcessInput;
        Add( kysymysIkkuna );
    }
    
    void ProcessInput( InputWindow ikkuna ) // prosessoi inputin kun panos on asetettu
    {
        string vastaus = ikkuna.InputBox.Text;
        if (double.TryParse(vastaus, out panos) && panos > 0 && panos <= pistelaskuri.Value)
        {
            panosLabel.Text = "Panos: " + Math.Round(panos, 2); // Update the display label
            
            MessageDisplay.Add("Panos hyväksytty: " + panos);
            panosAsetettu.TrySetResult(true);
            // Lisää logiikka panoksen käyttämiseksi pelissä
        }
        else if (vastaus == "max" || vastaus == "m" || vastaus == "a" || vastaus == "allin" || vastaus == "all in" || vastaus == "all" || vastaus == "kaikki" || vastaus == "inshallah" || vastaus == "0" && panos > 0 && panos < pistelaskuri.Value) //AllIn
        {
            panos = pistelaskuri.Value; 
            
            panosLabel.Text = "Panos: " + Math.Round(panos, 2); // Update the display label
                   
            MessageDisplay.Add("Panos hyväksytty: " + panos);
            panosAsetettu.TrySetResult(true);
            // Lisää logiikka panoksen käyttämiseksi pelissä   
        }
        else if (vastaus == "half" || vastaus == "h" || vastaus == "puolet" || vastaus == "p" || vastaus == "1/2" || vastaus == "^" && panos > 0 && panos < pistelaskuri.Value) //puolet inee
        {
                panos = pistelaskuri.Value/2; 
            
                panosLabel.Text = "Panos: " + Math.Round(panos, 2); // Update the display label
                   
                MessageDisplay.Add("Panos hyväksytty: " + panos);
                panosAsetettu.TrySetResult(true);
                // Lisää logiikka panoksen käyttämiseksi pelissä  
        }
        else
        {
            MessageDisplay.Add("Virheellinen panos. Aseta panos johon sinulla on varaa ja joka on positiivinen luku.");
            Keyboard.Listen(Key.P, ButtonState.Pressed, async () => await VaihdaPanos(), "vaihtaa panoksen");
            TakaisinPV();

        }
    }

    
    /// <summary>
    /// luo pelin plinko
    /// </summary>
    public async Task Plinko()
    {
        panosAsetettu = new TaskCompletionSource<bool>(false);  // Alustetaan uudelleen jokaiselle kierrokselle
        ClearControls();
        ClearGameObjects();
        Add(pistenaytto);
        await LisaaPanos();  // Odotetaan, kunnes panos on asetettu
        panosAsetettu.TrySetResult(true);  // Varmistetaan, että odotus päättyy
        panosLabel.Position = new Vector(0, Level.Top - 60);
        panosLabel.TextScale = new Vector(2,2);
        panosLabel.TextColor = Color.SkyBlue;
        panosLabel.Color = Color.Transparent;
        
        
        Level.Background.Image = taustakuvaPlinko;
        

        Gravity = new Vector(0, -200);

        for (int i = 2; i < 20; i++)
        {
                for (int j = 0; j <= i; j++)
                {
                    EstePlinko(this, 0 + j * 50 - i * 25, 300 - i * 30);
                }
        }
        
        KerroinAlla(0, 0.25*tsplinko * yTs);
        KerroinAlla(177, 0.75*tsplinko * yTs);
        KerroinAlla(-177, 0.75*tsplinko * yTs);
        KerroinAlla(316, 2.5*tsplinko * yTs);
        KerroinAlla(-316, 2.5*tsplinko * yTs);
        KerroinAlla(430, 5*tsplinko * yTs);
        KerroinAlla(-430, 5*tsplinko * yTs);
        KerroinAlla(520, 25*tsplinko * yTs);
        KerroinAlla(-520, 25*tsplinko * yTs);
        
        Keyboard.Listen(Key.P, ButtonState.Pressed, async () => await VaihdaPanos(), "vaihtaa panoksen");
        Keyboard.Listen(Key.Space, ButtonState.Down, ptpalloLuoja, "pudattaa pallon", this);
        Keyboard.Listen(Key.PageDown, ButtonState.Down, ptpalloLuoja, "pudattaa pallon", this);
        
        
        TakaisinPV();
    }
    

    
    /// <summary>
    /// luo putoavan pallon ja palkin josta saa (ehkä) rahat takaisin
    /// </summary>
    /// <param name="peli"></param>
    public void ptpalloLuoja(Game peli)
    {
        if (pistelaskuri.Value >= panos)
        {
            peliKesken += 1;
            pistelaskuri.Value -= panos;
            PhysicsObject ptpallo = new PhysicsObject(15, 15, Shape.Circle);
            ptpallo.Color=Color.Lime;
            ptpallo.Restitution = 0.35;
            ptpallo.X = RandomGen.NextDouble(-40,40);
            ptpallo.Y = 325;
            ptpallo.CollisionIgnoreGroup = 1; 
            peli.Add(ptpallo);
            
            PhysicsObject ptbot = new PhysicsObject(Screen.Width*2, 10, Shape.Rectangle);
            ptbot.Position = new Vector(0, Screen.Bottom+5); 
            ptbot.MakeStatic();  
            peli.Add(ptbot);
            
            ptpallo.Collided += (rhapallo, pantajapalkki) => 
            { 
                if (rhapallo == ptpallo && pantajapalkki == ptbot) 
                { 
                    ptpallo.Destroy();
                    peliKesken -= 1;
                } 
            };
            
            PisteAntaja(0, 200,  (0.25*tsplinko * yTs), ptpallo);
            PisteAntaja(177, 150, (0.75*tsplinko * yTs), ptpallo);
            PisteAntaja(-177, 150, (0.75*tsplinko * yTs), ptpallo);
            PisteAntaja(316, 125, (2.5*tsplinko * yTs),ptpallo);
            PisteAntaja(-316, 125, (2.5*tsplinko * yTs), ptpallo);
            PisteAntaja(430, 100, (5*tsplinko * yTs), ptpallo);
            PisteAntaja(-430, 100, (5*tsplinko * yTs), ptpallo);
            PisteAntaja(520, 75, (20*tsplinko * yTs), ptpallo);
            PisteAntaja(-520, 75, (20*tsplinko * yTs), ptpallo);

        }
        else
        {
            MessageDisplay.Add("Ei tarpeeksi rahaa panoksen asettamiseen.");
        }
    }

    public void KerroinAlla(double x, double panoskerroin)
    {
        double panoskerroindes = Math.Round(panoskerroin, 2);
        Label kerroinlabel = new Label("" + panoskerroindes)
        {
            Color = Color.OrangeRed,
            Position = new Vector(x,-340)// Asetetaan sijainti
        };
        Add(kerroinlabel);
    }
    
    
    /// <summary>
    /// luo annetun levyisen palkin joka antaa rahan takaisin annetulla kertoimella
    /// </summary>
    /// <param name="x">palkin x-koordinaatti</param>
    /// <param name="widht">palkin leveys</param>
    /// <param name="panoskerroin">kerroin jolla rahan saa takaisin kun osuu palkkiin(kokonaisluku)</param>
    /// <param name="pallo"> putoava pallo</param>
    public void PisteAntaja( double x, double widht, double panoskerroin, PhysicsObject pallo)
    {
        double tempPanos = panos;
        
        PhysicsObject pantaja = PisteKerroin(this,x,  widht ); // pisteidenantaja
        pallo.Collided += (rhapallo, pantajapalkki) => 
        { 
            if (rhapallo == pallo && pantajapalkki == pantaja) 
            { 
                pallo.Destroy();
                pistelaskuri.Value += tempPanos * panoskerroin * yTs; 
                peliKesken -= 1;
            } 
        };
        
    }
    public PhysicsObject PisteKerroin(Game peli, double x, double widht)
    {
        PhysicsObject pt = new PhysicsObject(widht, 10, Shape.Rectangle);
        pt.Position = new Vector(x, -325); 
        pt.MakeStatic();  
        peli.Add(pt);
        return pt;
    }
    
    
    /// <summary>
    /// luo staatisen pallon annettuun kohtaan
    /// </summary>
    /// <param name="peli"></param>
    /// <param name="x">paikka x-akseliilla</param>
    /// <param name="y">paikka y-akselilla</param>
    public void EstePlinko(Game peli, double x,double y)
    {
        PhysicsObject este = new PhysicsObject(10, 10, Shape.Circle, x, y );
        este.Restitution = 0.5;
        este.Color = Color.SkyBlue;
        este.MakeStatic(); 
        peli.Add(este);
    }
    
    public async Task Ruletti()
    {
        panosAsetettu = new TaskCompletionSource<bool>(false);
        
        ClearGameObjects();
        ClearControls();
        Level.Background.Image = taustakuvaRulet;
        Level.Background.Width = Screen.Width;
        Level.Background.Height = Screen.Height;
        Add(pistenaytto);
        await LisaaPanos();
        panosAsetettu.TrySetResult(true);

        await LuoPanostusAlue();
        
        TakaisinPV();
    }
    
    public async Task LuoPanostusAlue()
    {
        // Tyhjennetään välimuisti aina uuden alueen luomisen yhteydessä
        if (clickLog.Count > 0)
        {
            clickLog.Clear();
        }
        
        
        // Nollataan valmis-nappi, jotta se luodaan uudelleen tarvittaessa
        doneButton = null;
        
        ClearGameObjects();
        ClearControls();
        
        Label ohjeet = new Label(1100, 35, "Klikkaa mihin haluat asettaa panoksesi. Jos klikkaat montaa kohtaa niin panos jaetaan niiden välille tasan.");
        ohjeet.Color = Color.SkyBlue;
        ohjeet.TextColor = Color.Black;
        ohjeet.Position = new Vector(Screen.Right-575, Screen.Top-25);
        Add(ohjeet);
        
        // Tausta panostusalueelle
        GameObject panostusAlue = new GameObject(Screen.Width / 4, Screen.Height / 2, Shape.Rectangle);
        panostusAlue.Color = Color.DarkGreen;
        panostusAlue.Position = new Vector(0,0);
        Add(panostusAlue);
        
        // Grid-asetukset numeroiden nappeihin
        int buttonSize = 50;
        int padding = 5;
        int buttonsPerRow = 6; // Nappeja per rivi
        int totalButtons = 36;
        
        // Lasketaan gridin kokonaisleveys ja -korkeus
        double gridWidth = buttonsPerRow * buttonSize + (buttonsPerRow - 1) * padding;
        int totalRows = (totalButtons + buttonsPerRow - 1) / buttonsPerRow; // Pyöristys ylöspäin
        double gridHeight = totalRows * buttonSize + (totalRows - 1) * padding;
        
        // Asetetaan gridin aloituskohta panostusalueen sisällä niin, että se on keskitetty
        double startX = (panostusAlue.Position.X - gridWidth / 2 + buttonSize / 2);
        double startY = (panostusAlue.Position.Y + panostusAlue.Height / 2 - gridHeight / 2 - buttonSize / 2);
        
        //Console.WriteLine($"start x ={startX} ja start y = {startY}");
        
        for (int i = 0; i < totalButtons; i++)
        {
            int currentNumber = i+1; // pitää skipata 0 toistaiseksi, niille myöhemmin omat napit
            int row = i / buttonsPerRow;
            int col = i % buttonsPerRow;
            
            // Lasketaan napin sijainti gridissä
            double x = startX + col * (buttonSize + padding);
            double y = startY - row * (buttonSize + padding);
            
            GameObject numeroPanos = new GameObject(buttonSize, buttonSize);
            // Vaihdetaan väri parillisen ja parittoman mukaan
            if (currentNumber < 11) 
            {
                numeroPanos.Color = (currentNumber % 2 == 0) ? Color.Black : Color.Red;
            }
            else if (10 < currentNumber)
            {
                if (currentNumber < 29)
                {
                    if (currentNumber < 19)
                    {
                        numeroPanos.Color = (currentNumber % 2 == 0) ? Color.Red : Color.Black;
                    }
                    else
                    {
                        numeroPanos.Color = (currentNumber % 2 == 0) ? Color.Black : Color.Red;
                    }
                }
                else
                {
                    numeroPanos.Color = (currentNumber % 2 == 0) ? Color.Red : Color.Black;
                }
            }
            
            numeroPanos.Position = new Vector(x, y);
            numeroPanos.Tag = currentNumber;
            Add(numeroPanos);
            
            Label numeroLabel = new Label(buttonSize, buttonSize);
            numeroLabel.Text = currentNumber.ToString();
            numeroLabel.TextColor = Color.White;
            numeroLabel.Position = new Vector(x, y);
            numeroPanos.Add(numeroLabel);
            
            // Rekisteröidään napin hiiriklikkaus käyttäen paikallista muuttujaa
            Mouse.Listen(MouseButton.Left, ButtonState.Pressed, () =>
            {
                if (numeroPanos.IsInside(Mouse.PositionOnScreen))
                {
                    // Tallennetaan vain numero välimuistiin
                    clickLog.Add(numeroPanos.Tag.ToString());
                    AsetaPanos((int)numeroPanos.Tag);
                    if (doneButton == null)
                    {
                        CreateDoneButton();
                    }
                }
            }, "Aseta panos numerolle " + currentNumber);
        }
        
        GameObject gOPanos = new GameObject(150, 50);
        gOPanos.Color = Color.LimeGreen;
        // Asetetaan nappi hieman panostusalueen alapuolelle
        gOPanos.Position = new Vector(startX+52, startY+60);
        Add(gOPanos);
        
        Label gOLabel = new Label(150, 50);
        gOLabel.Text = "0";
        gOLabel.TextColor = Color.White;
        gOLabel.Position = new Vector(startX+52, startY+60);
        gOPanos.Add(gOLabel);
        
        Mouse.Listen(MouseButton.Left, ButtonState.Pressed, () =>
        {
            if (gOPanos.IsInside(Mouse.PositionOnScreen))
            {
                // Tallennetaan nolla välimuistiin
                clickLog.Add("0");
                AsetaPanosNollat("0");
                if (doneButton == null)
                {
                    CreateDoneButton();
                }
            }
        }, "Aseta panos nollalle");
        
        GameObject gO0Panos = new GameObject(150, 50);
        gO0Panos.Color = Color.LimeGreen;
        // Asetetaan nappi hieman panostusalueen alapuolelle
        gO0Panos.Position = new Vector(startX+220, startY+60);
        Add(gO0Panos);
        
        Label gO0Label = new Label(150, 50);
        gO0Label.Text = "00";
        gO0Label.TextColor = Color.White;
        gO0Label.Position = new Vector(startX+220, startY+60);
        gO0Panos.Add(gO0Label);
        
        Mouse.Listen(MouseButton.Left, ButtonState.Pressed, () =>
        {
            if (gO0Panos.IsInside(Mouse.PositionOnScreen))
            {
                // Tallennetaan tuplanolla välimuistiin
                clickLog.Add("00");
                AsetaPanosNollat("00");
                if (doneButton == null)
                {
                    CreateDoneButton();
                }
            }
        }, "Aseta panos tuplanollalle");
        
        GameObject punainenPanos = new GameObject(165, 60);
        punainenPanos.Color = Color.Red;
        // Asetetaan nappi hieman panostusalueen alapuolelle
        punainenPanos.Position = new Vector(startX+52, startY+125);
        Add(punainenPanos);
        
        Label punainenLabel = new Label(165, 60);
        punainenLabel.Text = "Punainen";
        punainenLabel.TextColor = Color.White;
        punainenLabel.Position = new Vector(startX+52, startY+125);
        punainenPanos.Add(punainenLabel);
        
        Mouse.Listen(MouseButton.Left, ButtonState.Pressed, () =>
        {
            if (punainenPanos.IsInside(Mouse.PositionOnScreen))
            {
                // Tallennetaan värin nimi välimuistiin
                clickLog.Add("Punainen");
                AsetaPanosVärille("Punainen");
                if (doneButton == null)
                {
                    CreateDoneButton();
                }
            }
        }, "Aseta panos värille Punainen");
     
        GameObject mustaPanos = new GameObject(165, 60);
        mustaPanos.Color = Color.Black;
        // Asetetaan nappi hieman panostusalueen alapuolelle
        mustaPanos.Position = new Vector(startX+220, startY+125);
        Add(mustaPanos);
        
        Label mustaLabel = new Label(165, 60);
        mustaLabel.Text = "Musta";
        mustaLabel.TextColor = Color.White;
        mustaLabel.Position = new Vector(startX+220, startY+125);
        mustaPanos.Add(mustaLabel);
        
        Mouse.Listen(MouseButton.Left, ButtonState.Pressed, () =>
        {
            if (mustaPanos.IsInside(Mouse.PositionOnScreen))
            {
                // Tallennetaan värin nimi välimuistiin
                clickLog.Add("Punainen");
                AsetaPanosVärille("Musta");
                if (doneButton == null)
                {
                    CreateDoneButton();
                }
            }
        }, "Aseta panos värille Musta");
        
        
    }

    void CreateDoneButton()
    {
        GameObject Done = new GameObject(150, 75);
        Done.Color = Color.Green;
        // Asetetaan nappi hieman panostusalueen alapuolelle
        Done.Position = new Vector(500,-200);
        Add(Done);
        
        Label DoneLabel = new Label(150, 75);
        DoneLabel.Text = "Valmis";
        DoneLabel.TextColor = Color.White;
        DoneLabel.Position = new Vector(500,-200);
        Done.Add(DoneLabel);
        
        Mouse.Listen(MouseButton.Left, ButtonState.Pressed, () =>
        {
            if (Done.IsInside(Mouse.PositionOnScreen))
            {
                panosAsetettu.TrySetResult(true);
                RulettiPyöritys();
            }
        }, "Aseta panos värille Musta");
    }
    
    void AsetaPanos(int numero)
    {
        MessageDisplay.Add($"Panos asetettu numeroon {numero}!");
    }
    
    void AsetaPanosVärille(string väri)
    {
        MessageDisplay.Add($"Panos asetettu värille {väri}!");
    }
    
    void AsetaPanosNollat(string nolla)
    {
        MessageDisplay.Add($"Panos asetettu numerolle {nolla}!");
    }
    
    void RulettiPyöritys()
    {
        ClearGameObjects();
        ClearControls();
        List<string> Betit = new HashSet<string>(clickLog).ToList();
        MessageDisplay.Add($"Panokset on jaettu kohtiin:{string.Join(", ", Betit)}");
        Console.WriteLine($"Panokset on jaettu kohtiin:{string.Join(", ", Betit)}");
        Console.WriteLine($"Panos per kohde on {panos} jaettuna {clickLog.Count} on {panos/clickLog.Count}");
        var rulettitaskut = CreateRouletteBets();
        Console.WriteLine($"lista kohdista: {string.Join(", ", rulettitaskut)}");
        RulettiAnimaatio();
        TakaisinPV();
    }

    void RulettiAnimaatio()
    {
        
    }

    public async Task Slots()
    {
        panosAsetettu = new TaskCompletionSource<bool>(false);
        ClearGameObjects();
        ClearControls();
        Add(pistenaytto);
        await LisaaPanos();  // Odotetaan, kunnes panos on asetettu
        panosAsetettu.TrySetResult(true);
        
        AlustusSlots();
        TakaisinPV();
    }

    Dictionary<Image, double> slotHinta  = new Dictionary<Image, double>();
    
    public void AlustusSlots()
    {
        Image slot6 = LoadImage("slotbanaani.png");
        Image slot5 = LoadImage("slotwatermalone.png");
        Image slot4 = LoadImage("slotomena.png");
        Image slot3 = LoadImage("slotpaaryna.png");
        Image slot2 = LoadImage("slotkirsikka.png");
        Image slot1 = LoadImage("slotwinwin.png");

        slotHinta[slot6] = 0.125;
        slotHinta[slot5] = 0.25;
        slotHinta[slot4] = 1;    
        slotHinta[slot3] = 2;
        slotHinta[slot2] = 10;
        slotHinta[slot1] = 1000;

        
        List<Image> slotImagesList = new List<Image>();
        
        

        int vaikeus = 6; 
        
        for (int i = 0; i < vaikeus-5; i++)
        {
            slotImagesList.Add(slot1);
            for (int j = 0; j < vaikeus-4; j++)
            {
                slotImagesList.Add(slot2);
                for (int k = 0; k < vaikeus; k++)
                {
                    slotImagesList.Add(slot3);
                    for (int l = 0; l < vaikeus-3; l++)
                    {
                        slotImagesList.Add(slot4);
                        for (int m = 0; m < vaikeus-3; m++)
                        {
                            slotImagesList.Add(slot5);
                            for (int n = 0; n < vaikeus-4; n++)
                            {
                                slotImagesList.Add(slot6);
                            }
                        }
                    }
                }
            }
        }
        
        Image[] slotImages = slotImagesList.ToArray();
        List<PhysicsObject> slotitList = new List<PhysicsObject>();
        LuoSlots(slotImages, slotitList);
        
        Keyboard.Listen(Key.Space, ButtonState.Pressed, () => PelaaSlots(slotImages, slotitList), "Pyrittää slotsit");
    }
    public async Task SamaSlots()
    {
        ClearGameObjects();
        ClearControls();
        Add(pistenaytto);
        AlustusSlots();
        TakaisinPV();
    }

    public async Task LuoSlots(Image[] slotImages,List<PhysicsObject> slotitList)
    {

        for (int i = 0; i < 4; i++)
        {
            for (int j = 0; j < 4; j++)
            {
                PhysicsObject slotit = new PhysicsObject(150 , 200, Shape.Rectangle, Level.Left + 600 + j * 250, Level.Bottom + i * 350);
                slotit.Image = slotImages[RandomGen.NextInt(0, slotImages.Length)];
                Add(slotit);
                slotitList.Add(slotit);
            }
        }
    }

    public async Task PelaaSlots(Image[] slotImages, List<PhysicsObject> slots)
    {
        ClearControls();
        peliKesken += 1;
        pistelaskuri.Value -= panos;
        Vector nopeus = new Vector(0, -3000);  //pelinopeus
        //Vector nopeus = new Vector(0, -500);  // testaus
        bool slotitPysaytetty = false;
        
        int rivit = 4;
        int kerrokset = 4;
        PhysicsObject[,] slotsGrid = new PhysicsObject[rivit, kerrokset];
        
        int slotIndex = 0;
        for (int i = 0; i < rivit; i++)
        {
            for (int j = 0; j < kerrokset; j++)
            {
                slotsGrid[i, j] = slots[slotIndex];
                slotIndex++;
            }
        }
        
        PhysicsObject stopper = new PhysicsObject(Level.Width, 3, Shape.Rectangle, 0, Level.Bottom - 200);
        stopper.MakeStatic();
        Add(stopper);
        
        while (!slotitPysaytetty)
        {
            foreach (var slot in slots)
            {
                slot.Velocity = nopeus; 
                slot.Collided += (ptpl, stoppalkki) => 
                { 
                    if (ptpl == slot && stoppalkki == stopper && !slotitPysaytetty) 
                    { 
                        slot.Velocity = nopeus; 
                        slot.Position = new Vector(slot.Position.X, Level.Top + 200); 
                        slot.Image = slotImages[RandomGen.NextInt(0, slotImages.Length)];
                    } 
                };
            }
            Keyboard.Listen(Key.Space, ButtonState.Pressed, () =>
            {
                foreach (var slot in slots)
                {
                    slot.Collided += (ptpl, stoppalkki) =>
                    {
                        if (ptpl == slotsGrid[3,0] && stoppalkki == stopper)
                        {
                            foreach (var slot in slots)
                            {
                                slot.Stop();
                                slot.MakeStatic();
                            }
                            slotitPysaytetty = true;
                        }
                    };
                };
            }, "pysäyttää slotit");
            await Task.Delay(100);
        }

        
        TseggaaPisteet(slotsGrid, slotImages);

        Keyboard.Listen(Key.P, ButtonState.Pressed, async () => await Slots(), "vaihtaa panoksen seuraavaan peliin"); 
        Keyboard.Listen(Key.Space, ButtonState.Pressed, async () => await SamaSlots(), "jatkaa samalla panoksella");
        
        TakaisinPV();
    }

    
    /// <summary>
    /// tarkistaa paljonko rahaa pitää antaa takaisin ja antaa sen
    /// </summary>
   
    public void TseggaaPisteet(PhysicsObject[,] slotsGrid, Image[] slotImages)
    {
        
       
        int rivit = slotsGrid.GetLength(0);
        int kerrokset = slotsGrid.GetLength(1);
        double kokoVoitto = 0;

        for (int i = 0; i < rivit - 1; i++)
        {
            int winKerroin = 1000;// vaihda myös alustusslot alusta
            int kirsikkaKerroin = 10; // ^^^^^^^^
            int count = 1;
            bool kiina1 = false;
            bool kirsikka1 = false;
            Image mikakuva = slotsGrid[i, 0].Image;
            if (mikakuva == slotImages[0]) // jos rivin ensimmäinen slotti on winwin vaihtaa pistetarkistuksen alun kerroksen toiseen slottiin
            {
                mikakuva = slotsGrid[i, 1].Image;
            }
            double riviVoitto = 0;
            for (int j = 1; j < kerrokset; j++)
            {
                if (slotsGrid[i, j].Image == slotImages[0]) // jos jokin rivin sloteista on winwin lisää panoksen winkertoimen kanssa rivivoittoon
                {
                    Console.WriteLine("win1");
                    riviVoitto += panos * winKerroin;
                }
                if (slotsGrid[i, 0].Image == slotImages[0] && kiina1 == false) // jos kerroksen ensinmäinen slottin on winwin lisää panoksen winkertoimen kanssa rivivoittoon
                {
                    Console.WriteLine("win2");
                    riviVoitto += panos * winKerroin;
                    kiina1 = true;
                }
                if (slotsGrid[i, j].Image == slotImages[1])  // jos jokin rivin sloteista on kirsikka lisää panoksen kirsikkakertoimen kanssa rivivoittoon
                {
                    Console.WriteLine("kirsikkaa1");
                    riviVoitto += panos * kirsikkaKerroin;
                }
                if (slotsGrid[i, 0].Image == slotImages[1] && kirsikka1 == false )// jos kerroksen ensinmäinen slottin on krisikka lisää panoksen kirsikkakertoimen kanssa rivivoittoon
                {
                    Console.WriteLine("kirsikkaa2");
                    riviVoitto += panos * kirsikkaKerroin;
                    kirsikka1 = true;
                } 
                if ((slotsGrid[i, j].Image == mikakuva && slotsGrid[i, j].Image == slotsGrid[i, j - 1].Image) ||
                    (slotsGrid[i, j].Image == slotImages[1] && slotsGrid[i, j].Image == slotsGrid[i, j - 1].Image) ||
                    (slotsGrid[i, j].Image == slotImages[0] && slotsGrid[i, j].Image == slotsGrid[i, j - 1].Image))// jos slotin kuva on sama kuine edellinene samalla rivillä olleen slotin kuva lisää count:tiin 1
                {
                    count++;
                    Console.WriteLine(count);
                }
                
            }
            if (count > 1 && slotHinta.ContainsKey(mikakuva))// jos count on enemmän kuin yksi lisätään rivivoittoon saadun voiton 
            {
                Console.WriteLine("panos: " + panos + "slothinta: " + slotHinta[mikakuva] + "count: " + count);
                if (mikakuva != slotImages[0])
                {
                    riviVoitto += panos * slotHinta[mikakuva] * count;
                }
            }

            Console.WriteLine($"rivivoitto :{riviVoitto} rivilla {i}");
            kokoVoitto += riviVoitto;
            Console.WriteLine(kokoVoitto);
        }

        pistelaskuri.Value += kokoVoitto;
        peliKesken -= 1;
    }
    

    public async Task Coinflip()
    {
        ClearGameObjects();
        Add(pistenaytto);
        panosAsetettu = new TaskCompletionSource<bool>(false);  // Alustetaan uudelleen jokaiselle kierrokselle
        Level.Background.Image = taustakuvaCF;
        Level.Background.Width = Screen.Width;
        Level.Background.Height = Screen.Height;
        await LisaaPanos();  // Odotetaan, kunnes panos on asetettu
        panosAsetettu.TrySetResult(true);  // Varmistetaan, että odotus päättyy 
        TakaisinPV();
        ClearControls();
        InitializeCoinFlip();
        EnsimmäinenFlibidi();
            
    }

    public async Task EnsimmäinenFlibidi()
    {
        if (panos <= pistelaskuri.Value)
        {
            kerroinCF = 1.9;
            keratytRahatCF = 0;
            peliKesken += 1;
            pistelaskuri.Value -= panos;
            AsetaVeikkaus();
        }
        else
        {
            MessageDisplay.Add("Raha ei riitä tällä panoksella pelaamiseen");
            Coinflip();
        }
        
        TakaisinPV();
    }

    async Task AsetaVeikkaus()
    {
        ClearControls();
        panosLabel.Position = new Vector(0,Level.Top-75);
        Label kerroin = new Label("Kerroin: "+Math.Round(kerroinCF, 1))
        {
            Color = Color.Transparent,
            TextColor = Color.YellowGreen,
            TextScale = new Vector(2, 2),
            Position = new Vector(0, Level.Top-125)
        };
        Add(kerroin);
        Label potti = new Label("Kerätty rahapotti: "+Math.Round(keratytRahatCF, 2))
        {
            Color = Color.Transparent,
            TextColor = Color.Yellow,
            TextScale = new Vector(2, 2),
            Position = new Vector(0, Level.Top-175)
        };
        Add(potti);
        await Task.Delay(100);
        // Näytetään pelaajalle valinta
        Label veikkausLabel = new Label("Veikkaa: 'K' Kruuna tai 'C' Klaava")
        {
            Color = Color.White,
            Position = new Vector(0, -275),
            TextScale = new Vector(2, 2)
        };
        Add(veikkausLabel);
        await Task.Delay(100);
        // Kuunnellaan näppäimistösyötteet, jolloin pelaaja voi valita kruunan ('K') tai klaavan ('C')
        Keyboard.Listen(Key.K, ButtonState.Pressed, () =>
        {
            Remove(veikkausLabel);
            Remove(kerroin);
            Remove(potti);
            HeitaKolikko(true);
        }, "Veikkaa kruuna");
        Keyboard.Listen(Key.C, ButtonState.Pressed, () =>
        { 
            Remove(veikkausLabel);
            Remove(kerroin);
            Remove(potti);
            HeitaKolikko(false);
        }, "Veikkaa klaava");
    }
    
    private async Task HeitaKolikko(bool veikkausKruuna)
    {
        ClearControls();
        Random rand = new Random();
        bool kolikkoKruuna = rand.Next(2) == 0;  // Kruuna (true) vai Klaava (false)
        Console.WriteLine("kolikko kruuna "+kolikkoKruuna);
        animaatioValmis = new TaskCompletionSource<bool>();
        
        // Käynnistetään animaatio
        StartRandomCoinFlipAnimation(kolikkoKruuna);
    
        // Odotetaan, kunnes animaatio on valmis
        await animaatioValmis.Task;


        // Tarkistetaan voittiko pelaaja
        if (kolikkoKruuna == veikkausKruuna)
        {
            // Voitto - kerätään rahaa mutta ei lisätä sitä rahasaldoon vielä
            keratytRahatCF = panos * kerroinCF;
            
            kerroinCF *= 2.15;  // Kerroin tuplaantuu plus pikku bonari
            MessageDisplay.Add($"Voitit! Kerätyt rahat: {Math.Round(keratytRahatCF, 0)}, Kerroin: {Math.Round(kerroinCF, 1)}");
            Console.WriteLine($"Voitit! Kerätyt rahat: {keratytRahatCF}, Kerroin: {kerroinCF}");
            //Console.WriteLine("pelaaja voitti kun veikkasi kruuna"+veikkausKruuna +" tulos oli"+kolikkoKruuna);
            JatkaViela(); // Pelaaja voi päättää jatkaako peliä vai ei
        }
        else
        {
            peliKesken -= 1;
            // Häviö - menettää kaikki kerätyt rahat
            MessageDisplay.Add($"Hävisit! Kerätyt rahat menivät. Kerätyt rahat: {Math.Round(keratytRahatCF, 1)}");
            Console.WriteLine($"Hävisit! Kerätyt rahat menivät. Kerätyt rahat: {keratytRahatCF}");
            keratytRahatCF = 0;  // Nollataan kerätyt rahat
            //Console.WriteLine("pelaaja hävisi kun veikkasi kruuna"+veikkausKruuna +" tulos oli"+kolikkoKruuna);
            Label uusi = new Label("Haluatko aloittaa uuden kierroksen samalla panoksella (n), vaihtaa panosta (p) vai poistua pelistä (0)?")
            {
                Color = Color.White,
                Position = new Vector(0, -275), // Asetetaan sijainti
                TextScale = new Vector(1,1)
            };
            Add(uusi);
            Keyboard.Listen(Key.P, ButtonState.Pressed, async () =>
            {
                Remove(uusi);
                await Coinflip();
            }, "uus kiesi uudella panoksella"); // MUUTA MYÖHEMMIN KOSKA UUSI KIESI LUO UUDEN PAKAN
            Keyboard.Listen(Key.N, ButtonState.Pressed, async () =>
            {
                Remove(uusi);
                await EnsimmäinenFlibidi();
            }, "uus kiesi");
            TakaisinPV();
        }
    }

     void InitializeCoinFlip()
    {
        Console.WriteLine("Coinflip kuvaluettelo tehdään");
        //1 Ladataan kolikonheittokuvia animaatiota varten
        // Ladataan kuvat mutta ei anneta niiden skaalautua objektin koon mukaan
        for (int i = 0; i < coinFlipImages.Length; i++)
        {
            coinFlipImages[i] = LoadImage($"coin{i + 1}.png");
        }
        
        if (coinFlipImages[0] == null)
        {
            Console.WriteLine("nyt kusee");
        }
        
        // Luodaan GameObject animaatiolle ja lisätään peliin
        //coinObject = new PhysicsObject(200, 200, Shape.Circle); // physics object, jonka koko 200x200
        
        coinObject = new GameObject(coinFlipImages[0].Width*1.2, coinFlipImages[0].Height*1.2);
        coinObject.Position = new Vector(0, 25);
        coinObject.Image = coinFlipImages[0];
        Add(coinObject,1);
        Console.WriteLine("Coinobject added");
    }
    
    void StartRandomCoinFlipAnimation(bool kruuna)
    {
        // Luodaan animaatio ladatuista kuvista
        Animation coinFlipAnimation = new Animation(coinFlipImages);
            coinFlipAnimation.FPS = 14; // Nopeus x framea sekunnissa
        //coinFlipAnimation.Loop = true; // Pyörii jatkuvasti
        
        // Asetetaan animaatio GameObjectin kuvaksi ja käynnistetään animaatio
        Console.WriteLine("Coinflip animaatio aloitettu");
        coinObject.Animation = coinFlipAnimation;
        
        coinObject.Animation.Start();
       
        // Ajastin pysäyttämään animaation satunnaisen ajan jälkeen
        Timer.SingleShot(RandomGen.NextDouble(1, 5), () =>
        {
            coinObject.Animation.Stop();
            Console.WriteLine("Coinflip animaatio pysäytetty");

            // Valitaan pysäytyskuva onHeads-muuttujan perusteella
            coinObject.Image = kruuna ? coinFlipImages[0] : coinFlipImages[4];
            animaatioValmis.TrySetResult(true);
        });
    }
    

    
// Tämä metodi kysyy pelaajalta, haluaako hän jatkaa peliä
    async Task JatkaViela()
    {
        ClearControls();
        Label kerroin = new Label("Seuraava kerroin: "+Math.Round(kerroinCF, 1))
        {
            Color = Color.Transparent,
            TextColor = Color.Gold,
            TextScale = new Vector(2, 2),
            Position = new Vector(0, Level.Top-125)
        };
        Add(kerroin);
        Label potti = new Label("Kerätty rahapotti: "+Math.Round(keratytRahatCF, 2))
        {
            Color = Color.Transparent,
            TextColor = Color.Gold,
            TextScale = new Vector(2, 2),
            Position = new Vector(0, Level.Top-175)
        };
        Add(potti);
        Label JatkaCF = new Label("Haluatko jatkaa (j) vai lopettaa ja ottaa kerätyt rahat pois (p)?")
        {
            Color = Color.Wheat,
            Position = new Vector(0, -250),
            TextScale = new Vector(1,1)
        };
        Add(JatkaCF);
        await Task.Delay(200);
        // Kuunnellaan pelaajan syöte - jos pelaaja haluaa jatkaa, peli jatkuu
        Keyboard.Listen(Key.J, ButtonState.Pressed, () =>
        {
            Remove(JatkaCF);
            Remove(kerroin);
            Remove(potti);
            // Pelaaja haluaa jatkaa, joten peli etenee
            AsetaVeikkaus();  // Asetetaan uusi veikkaus
        }, "Jatka peliä (J)");

        // Jos pelaaja ei halua jatkaa, hän voi ottaa rahat
        Keyboard.Listen(Key.P, ButtonState.Pressed, () =>
        {
            ClearControls();
            peliKesken -= 1;
            Remove(JatkaCF);
            Remove(kerroin);
            Remove(potti);
            // Pelaaja ei halua jatkaa, ottaa kerätyt rahat
            pistelaskuri.Value += Math.Round(keratytRahatCF * yTs, 2);  // Lisää kerätyt rahat pelaajan saldolle
            keratytRahatCF = 0;  // Nollaa kerätyt rahat
            MessageDisplay.Add($"Peli loppui. Rahasaldo: {pistelaskuri.Value}");
            Console.WriteLine($"Peli loppui. Rahasaldo: {pistelaskuri.Value}");
            Label uusi = new Label("Haluatko aloittaa uuden kierroksen samalla panoksella (n), vaihtaa panosta (p) vai poistua pelistä (0)?")
            {
                Color = Color.White,
                Position = new Vector(0, -275), // Asetetaan sijainti
            };
            Add(uusi);
            Keyboard.Listen(Key.P, ButtonState.Pressed, async () =>
            {
                Remove(uusi);
                await Coinflip();
            }, "uus kiesi uudella panoksella"); // MUUTA MYÖHEMMIN KOSKA UUSI KIESI LUO UUDEN PAKAN
            Keyboard.Listen(Key.N, ButtonState.Pressed, async () =>
            {
                Remove(uusi);
                await EnsimmäinenFlibidi();
            }, "uus kiesi");
            TakaisinPV();  // Siirtyy takaisin pelinvalintaan
        }, "Ota rahat ja lopeta (P)");
    }
  
    
    void AddRaha()
    {
        pistelaskuri.Value += 250000;
    }
    
    /// <summary>
    /// siirtyy takaisin Pelinvalintaan
    /// </summary>
    void TakaisinPV()
    {
        Keyboard.Listen(Key.D0, ButtonState.Pressed, () =>
        {
            peliKesken = 0;
            ClearControls();
            ClearGameObjects();
            PelinValinta();
        }, "Siirry takaisin pelinvalintaan");
    }
    
    
    /// <summary>
    /// luo suorakulmion annettun kokoon ja paikkaan
    /// </summary>
    /// <param name="peli"></param>
    /// <param name="width">logon leveys</param>
    /// <param name="height">logon korkeus</param>
    /// <param name="x">logon paikka</param>
    /// <param name="y">logon paikka</param>
    public void MiniPeliLogo(Game peli, double width, double height, double x, double y, string kuva, int order)
    {
        PhysicsObject p = new PhysicsObject(width, height, Shape.Rectangle, x, y);
        p.Image = LoadImage(kuva); 
        Label iconLab = new Label(kuva+$" ({order})")
        {
            
            Color = Color.White,
            Position = new Vector(x, y-90), // Asetetaan sijainti
        };
        peli.Add(p);
        peli.Add(iconLab);
        
    }
    async Task Voitto()
    {
        Console.WriteLine(finalscore);
        voitto = true;
        ClearAll();
        ScoreBoard();
    }
    async Task Defeat()
    {
        Console.WriteLine(finalscore);
        ClearAll();
        ScoreBoard();  // Odotetaan, kunnes panos on asetettu
    }

    private void ScoreBoard()
    {
        topLista.EnterAndShow(finalscore);
        topLista.HighScoreWindow.Closed += loppuTekstit;
    }

    private void loppuTekstit(Window sender)
    {
        ClearAll();
        if (voitto)
        {
            Label uusi = new Label("Voitit Pelin!!!")
            {
                Color = Color.White,
                Position = new Vector(0, 0), // Asetetaan sijainti
                TextScale = new Vector(3, 3)
            };
            Add(uusi);
        }
        else
        {
            Console.WriteLine("hävisit pelin");
            Label uusi = new Label("Hävisit pelin")
            {
                Color = Color.White,
                Position = new Vector(0, 25), // Asetetaan sijainti
                TextScale = new Vector(3, 3)
            };
            Add(uusi);
            Label uusi2 = new Label("Poikasi teloitettiin.")
            {
                Color = Color.Transparent,
                TextColor = Color.Red,
                Position = new Vector(0, -50), // Asetetaan sijainti
                TextScale = new Vector(3, 3)
            };
            Add(uusi2);
        }
        Task.Delay(100);
        Label uusi3 = new Label("Yritä uudelleen (N), katso parhaat pisteet (S) tai luovuta (Esc)")
        {
            Color = Color.Transparent,
            TextColor = Color.Violet,
            Position = new Vector(0, Level.Bottom+50), // Asetetaan sijainti
            TextScale = new Vector(3, 3)
        };
        Add(uusi3);
        Label uusi4 = new Label("Sait "+finalscore+" pistettä")
        {
            Color = Color.Transparent,
            TextColor = Color.Green,
            Position = new Vector(0, Level.Bottom+200), // Asetetaan sijainti
            TextScale = new Vector(3, 3)
        };
        Add(uusi4);
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, () =>
        {
            ClearAll();
            Exit();
        }, "ulos");
        Keyboard.Listen(Key.S, ButtonState.Pressed, () =>
        {
            topLista.Show();
            topLista.HighScoreWindow.Position = new Vector(Screen.Right-225,0);
        }, "Scoreboard");
        Keyboard.Listen(Key.N, ButtonState.Pressed, () =>
        {
            ClearAll();
            peliKesken = 0;
            peliOhi = false;
            pistelaskuri = null;
            Begin();
        }, "uus kiesi");
    }
}}